/***************************************************************************
                          CdboCompilationView.h  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CDBOCOMPILATIONVIEW_H
#define CDBOCOMPILATIONVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt
#include <qwidget.h>
#include <qgrid.h>
#include <kio/job.h>


// forward declaration of the CdboCompilationView classes
class TargetTreeCntPanel;
class EstimatePnl;
class CompilationTreeView;
class CDBakeOvenApp;

class CdboCompilationView : public QGrid{
  Q_OBJECT
public:
    /** Constructor for the main view */
    CdboCompilationView(CDBakeOvenApp * cdboApp, QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~CdboCompilationView();

	inline CDBakeOvenApp* getCdboApp() { return cdboApp; }
	
public slots:
	virtual void showTargetControl(bool);
	virtual void showEstimate(bool);


protected:
  	CDBakeOvenApp *cdboApp;
	
};

#endif // CDBOCOMPILATIONVIEW_H