/***************************************************************************
                          NewAudioCdCompilationView.h  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef NEWAUDIOCDCOMPILATIONVIEW_H
#define NEWAUDIOCDCOMPILATIONVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt
#include <qwidget.h>

#include "CdboCompilationView.h"

// forward declaration of the NewAudioCdCompilationView classes
class AudioTreeCntPanel;
class AudioEstimatePnl;
class AudioCompilationTreeView;
class CDBakeOvenApp;

class NewAudioCdCompilationView : public CdboCompilationView{
  Q_OBJECT
public:
    /** Constructor for the main view */
    NewAudioCdCompilationView(CDBakeOvenApp * cdboApp, QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~NewAudioCdCompilationView();

	void saveOptions();
	inline AudioCompilationTreeView* getView() { return compilView;}
	
public slots:
	virtual void showTargetControl(bool);
	virtual void showEstimate(bool);


private:
  	void initView();
  	
  	//members
  	
  	AudioTreeCntPanel *targetCnt;
  	AudioEstimatePnl* estimate;
  	AudioCompilationTreeView *compilView;

	
};

#endif // NEWAUDIOCDCOMPILATIONVIEW_H