/***************************************************************************
                          NewCdDialogBase.h  -  description
                             -------------------
    begin                : Sun May 13 2001
    copyright            : (C) 2001 by Alexy Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef NEWCDDIALOGBASE_H
#define NEWCDDIALOGBASE_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class DialogCntPnl;
class DriveInfoPnl;
class QCheckBox;
class QComboBox;
class QFrame;
class QGroupBox;
class QLabel;
class QPushButton;
class QSpinBox;
class SpeedPnl;

class NewCdDialogBase : public QDialog
{ 
    Q_OBJECT

public:
    NewCdDialogBase( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~NewCdDialogBase();

    QFrame* Frame5;
    DriveInfoPnl* targetDevicePnl;
    SpeedPnl* speedPnl;
    DialogCntPnl* dialogCntPnl;
    QFrame* detailsPnl;
    QGroupBox* GroupBox6;
    QSpinBox* numberSpn;
    QLabel* numOfCopiesLbl;
    QPushButton* customBurnBtn;
    QComboBox* actionCmb;
    QGroupBox* GroupBox6_2;
    QLabel* imageLbl;
    QPushButton* imageBrowseBtn;
    QPushButton* isoPreviewBtn;
    QPushButton* isoOptionsBtn;
    QCheckBox* removeIsoChk;

protected slots:
    virtual void customBtnSlot();
    virtual void isoBrowseSlot();
    virtual void isoOptionsSlot();
    virtual void isoPreviewSlot();

protected:
    QGridLayout* NewCdDialogBaseLayout;
    QVBoxLayout* Frame5Layout;
    QVBoxLayout* detailsPnlLayout;
};

#endif // NEWCDDIALOGBASE_H
