/***************************************************************************
                          AudioOptPnl.h  -  description
                             -------------------
    begin                : Sat May 5 2001
    copyright            : (C) 2001 by Alexy Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef AUDIOOPTPNL_H
#define AUDIOOPTPNL_H

#include <qvariant.h>
#include <qwidget.h>
#include <qtabwidget.h>

#include <kconfig.h>

#include "AudioOptPnlBase.h"

class AudioOptPnl : public AudioOptPnlBase{
    Q_OBJECT

public:
    AudioOptPnl( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    AudioOptPnl(int activeTab = 0, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~AudioOptPnl();
	
    void saveOptions();	
	void readOptions();
	void applyDefaults();
	
protected slots:
    	virtual void cdda2wavSlot();
    	virtual void extractAllSlot();
    	virtual void cdparanoiaSlot();
	virtual void  fromTrackAddSlot(int);
	virtual void kdeDetectSlot();
	virtual void cdboDetectSlot();
	void toTrackAddSlot(int);

private:
	
	//////////////////////////
	KConfig *config;
};

#endif // AUDIOOPTPNLBASE_H
