/***************************************************************************
                          AudioPicker.h  -  description
                             -------------------
    begin                : Sun Nov 11 2001
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AUDIOPICKER_H
#define AUDIOPICKER_H

#include <kio/job.h>

class AudioPicker : public KIO::Job{


  Q_OBJECT
//protected:
protected:
	AudioPicker( const KURL &);
	~AudioPicker() {}

public:
	static AudioPicker * audioPickerJob(const KURL &);
	
signals:
	void gotAudioFile(QString);
	
protected:
	void startNextJob( const KURL &);
	
protected slots:
	virtual void slotResult( KIO::Job *job );
	void slotEntries( KIO::Job * , const KIO::UDSEntryList & );
	void processList();

private:
	bool m_bAsync;
	long long m_totalSize;
	QStringList m_lstItems;
	QString pathToProcess;
	QStringList extList;
	bool cdboDtct;
	

};
#endif


